#include <bits/stdc++.h>
using namespace std;
typedef signed long long ll;
const ll MOD = 1000000007;
const ll MAXN = 1e12+7;

ll pow(ll a, ll n){
    ll ret = 1;
    while(n > 0){
        if(n%2 == 1){
            ret *= a;
            ret %= MOD;
        }
        a *= a;
        a %= MOD;
        n /= 2;
    }
    return ret;
}

ll getSum(ll a, ll b){
//    cout << "getSum(" << a << ", " << b << ")\n";
    ll times = (b-a+1)/2;
    ll add = (a+b)%MOD;
    ll ret = (times*add)%MOD;
    if((b-a+1)%2 == 1){
        ret += add/2;
        ret %= MOD;
    }
//    cout << "\t" << ret << "\n";
    return ret;
}

int main(){
    ll n;
    cin >> n;
    ll sqrtN = sqrt(n);

    ll sum = 0;
    for(ll i = 1; i <= sqrtN; i++){
        ll times = (n/i);
        ll add = (times*i) % MOD;
        add = (add*2) % MOD;
        sum = (sum + add) % MOD;
    }

    sum += getSum(n/2+1, n);
    sum %= MOD;

    cout << sum << '\n';

    return 0;
}
