/// molq te trugni
/// samoubiistwo on the to-do list
#include<iostream>

#define endl '\n'

using namespace std;

const int MOD=1e9+7;

long long int n;

void read()
{
	cin>>n;
}

long long int fast_pow(long long int a,long long int b,long long int f)
{
	long long int ans=1;
	a%=f;
	while(b>0)
	{
		if(b%2!=0)
		{
			ans=((ans*a)%f)%MOD;
		}
		b/=2;
		a=((a*a)%f)%MOD;
	}
	return ans%f;
}

long long int inv(long long int a)
{
	return fast_pow(a,MOD-2,MOD);
}

long long int find_suma(long long int n)
{
	return ((((n%MOD)*((n+1)%MOD))%MOD)*inv(2))%MOD;
}

void solve()
{
	long long int l=1;
	long long int ans=0;
	long long int m,r;
	while(l<=n)
	{
		m=n/l;
		r=n/m;
		m%=MOD;
		ans+=((find_suma(r)- find_suma(l-1)%MOD)*m)%MOD;
		ans%=MOD;
		l=r+1;
	}
	ans%=MOD;
	if(ans<0)
	{
		cout<<ans+MOD<<endl;
	}
	else
	{
		cout<<ans<<endl;
	}
}

int main()
{
	// freopen("input.in", "r", stdin);
    // freopen("output.out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	read();
	solve();

    return 0;
}