#include<iostream>

#define endl '\n'
#define ll long long int 

using namespace std;

const int MOD=1e9+7;

ll n;

ll fast_pow(ll a,ll b,ll f)
{
    ll ans=1;
    a%=f;
    a%=MOD;
    while(b>0)
    {
        if(b&1)
        {
            ans=(ans*a)%f;
        }
        b=b>>1;
        a=(a*a)%f;
        ans%=MOD;
    }
    return ((ans+f)%f+MOD)%MOD;
}

ll inv(ll a)
{
    return fast_pow(a,MOD-2,MOD);
}

ll find_suma(ll n)
{
    ll ans=((((n%MOD)*((n+1)%MOD))%MOD)*inv(2))%MOD;
    return ans;
}

ll solve2()
{
    ll l=1;
    ll ans=0;
    ll m,r;
    while(l<=n)
    {
        m=n/l;
        r=n/m;
        m%=MOD;
        ans+=((find_suma(r)- find_suma(l-1)%MOD)*m)%MOD;
        ans%=MOD;
        l=r+1;
    }
    ans%=MOD;
    if(ans<0)
    {
        return ans+MOD;
    }
    else
    {
        return ans;
    }
}

void read()
{
	cin>>n;
}


int main()
{
	// freopen("input.in", "r", stdin);
    // freopen("output.out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	read();
	cout<<solve2()<<endl;

    return 0;
}

