#include <bits/stdc++.h>
using namespace std;
typedef signed long long ll;
const ll MOD = 998244353;
const ll MAXN = 5007;

string getInteresting(ll n){
    string str = "a";
    char next = 'b';
    while(str.size()*2+1 <= n){
        const ll sz = str.size();
        str.resize(sz*2 + 1);
        str[sz] = next++;
        for(int i = 0; i < sz; i++){
            str[sz+1+i] = str[i];
        }
    }
    return str;
}

ll dp[MAXN][MAXN];

int main(){
    int n;
    string s;
    cin >> s;
    n = s.size();

    ///

    string inter = getInteresting(n);

    dp[0][0] = (s[0] == 'a');
    for(int i = 1; i < n; i++){
        dp[0][i] = (dp[0][i-1] + (s[i] == 'a')) % MOD;
    }
    for(int m = 1; m < inter.size(); m++){
        for(int i = 1; i < n; i++){
            dp[m][i] = dp[m][i-1];
            if(s[i] == inter[m]){
                dp[m][i] += dp[m-1][i-1];
                dp[m][i] %= MOD;
            }
        }
//        for(int i = 0; i < n; i++){
//            cout << dp[m][i] << ' ';
//        }cout << '\n';
    }

    ll sum = 0;
    for(int m = 1; m <= inter.size(); m=m*2+1){
        sum += dp[m-1][n-1];
        sum %= MOD;
    }

    cout << sum << '\n';
    return 0;
}
