#include <iostream>
#include <cmath>

#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'

using namespace std;

int divSum(int n)
{
    if(n == 1) return 1;
    int result = 0;
    for (int i = 2; i <= sqrt(n); i++)
    {
        if (n % i == 0)
        {
            if (i == (n / i)) result += i;
            else result += (i + n/i);
        }
    }
    return (result + n + 1);
}

int num;

void solve()
{
    long long ans = 0;
    cin >> num;
    for(int i = 1; i <= num; i++)
    {
        ans += divSum(i);
    }
    cout << ans << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
