#include <iostream>
#include <string>
#include <cstring>

#define maxn 100005
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define mod 998244353

using namespace std;

int z[maxn];
int n;
string alphabet = "abcdefghijklmnopqrstuvwxyz";

void z_func(string s)
{
    memset(z , 0 , sizeof(z));
    int n = s.size();
    int l = 0, r = 0;
    for(int i = 1; i < n; i++)
    {
        if(i < r)
        {
            z[i] = min(r - i, z[i - l]);
        }
        while(i + z[i] < n && s[z[i]] == s[i + z[i]])
        {
            z[i]++;
        }
        if(i + z[i] > r)
        {
            l = i;
            r = i + z[i];
        }
    }
}

string s;

void read()
{
    cin >> s;
    int i = 0;
    string tekst;
    long long ans = 0;
    string t = "" , prev;
    while(t.size() <= s.size() && i < 26)
    {
        prev = t;
        t = prev + alphabet[i] + prev;
        if(t.size() > s.size()) break;
        tekst = t + "#" + s;
        z_func(tekst);
        for(int i = 1; i < tekst.size(); i++)
        {
            if(z[i] == t.size()) ans++;
        }
        ///cout << t << " " << ans << endl;
        ans %= mod;
        i++;
    }
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    read();

    return 0;
}
